---
title: List Custom CSRs
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Custom Csrs](https://developers.cloudflare.com/api/go/resources/custom_csrs)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# List Custom CSRs

client.CustomCsrs.List(ctx, params) (\*V4PagePaginationArray\[[CustomCsrListResponse](<https://developers.cloudflare.com/api/go/resources/custom_csrs#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)>)], error)

GET/{accounts\_or\_zones}/{account\_or\_zone\_id}/custom\_csrs

List all custom Certificate Signing Requests (CSRs) for an account or zone.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account: SSL and Certificates Read``Account: SSL and Certificates Write`

##### ParametersExpand Collapse

<details>

<summary>

params CustomCsrListParams

</summary>

AccountID param.Field\[string]Optional

Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

ZoneID param.Field\[string]Optional

Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID.

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

Direction param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">CustomCsrListParamsDirection</a>]Optional

Query param: The direction to sort by.

</summary>

const CustomCsrListParamsDirectionAsc <a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">CustomCsrListParamsDirection</a> = "asc"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const CustomCsrListParamsDirectionDesc <a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)">CustomCsrListParamsDirection</a> = "desc"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20direction">Link to this property</a>

<details>

<summary>

Order param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)">CustomCsrListParamsOrder</a>]Optional

Query param: The field to sort the returned custom CSRs by.

</summary>

const CustomCsrListParamsOrderName <a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)">CustomCsrListParamsOrder</a> = "name"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const CustomCsrListParamsOrderAccountTag <a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)">CustomCsrListParamsOrder</a> = "account\_tag"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

const CustomCsrListParamsOrderCreatedAt <a href="https://developers.cloudflare.com/api/go/resources/custom_csrs/methods/list#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)">CustomCsrListParamsOrder</a> = "created\_at"

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20order">Link to this property</a>

Page param.Field\[float64]Optional

Query param: Page number of paginated results.

minimum1

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20page">Link to this property</a>

PerPage param.Field\[float64]Optional

Query param: Number of custom CSRs per page.

maximum50

minimum5

<a href="#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20per_page">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_csrs%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type CustomCsrListResponse struct{…}

A custom Certificate Signing Request (CSR).

</summary>

ID string

Custom CSR identifier tag.

maxLength36

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

CreatedAt Time

When the CSR was created.

formatdate-time

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

<details>

<summary>

KeyType CustomCsrListResponseKeyType

The key algorithm used to generate the CSR.

</summary>

One of the following:

const CustomCsrListResponseKeyTypeRsa2048 CustomCsrListResponseKeyType = "rsa2048"

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20key_type%20%3E%20(member)%200">Link to this property</a>

const CustomCsrListResponseKeyTypeP256v1 CustomCsrListResponseKeyType = "p256v1"

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20key_type%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20key_type">Link to this property</a>

AccountTag stringOptional

Account identifier associated with this CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20account_tag">Link to this property</a>

CommonName stringOptional

The common name (domain) for the CSR.

maxLength64

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20common_name">Link to this property</a>

Country stringOptional

Two-letter ISO 3166-1 alpha-2 country code.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20country">Link to this property</a>

Csr stringOptional

The PEM-encoded Certificate Signing Request.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20csr">Link to this property</a>

Description stringOptional

Optional description for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

Locality stringOptional

City or locality name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20locality">Link to this property</a>

Name stringOptional

Human-readable name for the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

Organization stringOptional

Organization name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20organization">Link to this property</a>

OrganizationalUnit stringOptional

Organizational unit name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20organizational_unit">Link to this property</a>

Sans \[]stringOptional

Subject Alternative Names included in the CSR.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20sans">Link to this property</a>

State stringOptional

State or province name.

<a href="#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)%20%3E%20(property)%20state">Link to this property</a>

</details>

[Link to this property](<#(resource)%20custom_csrs%20%3E%20(model)%20CustomCsrListResponse%20%3E%20(schema)>)

### List Custom CSRs

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/custom_csrs"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  page, err := client.CustomCsrs.List(context.TODO(), custom_csrs.CustomCsrListParams{

  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
      "created_at": "2024-01-15T10:30:00Z",
      "key_type": "rsa2048",
      "account_tag": "23e087bd19bc1d40ae95b6f297263ceb",
      "common_name": "example.com",
      "country": "US",
      "csr": "-----BEGIN CERTIFICATE REQUEST-----\nMIICYzCCAUsCAQAwHj...",
      "description": "CSR for example.com wildcard",
      "locality": "San Francisco",
      "name": "My Custom CSR",
      "organization": "Cloudflare, Inc.",
      "organizational_unit": "Engineering",
      "sans": [
        "example.com",
        "www.example.com"
      ],
      "state": "California"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752",
      "created_at": "2024-01-15T10:30:00Z",
      "key_type": "rsa2048",
      "account_tag": "23e087bd19bc1d40ae95b6f297263ceb",
      "common_name": "example.com",
      "country": "US",
      "csr": "-----BEGIN CERTIFICATE REQUEST-----\nMIICYzCCAUsCAQAwHj...",
      "description": "CSR for example.com wildcard",
      "locality": "San Francisco",
      "name": "My Custom CSR",
      "organization": "Cloudflare, Inc.",
      "organizational_unit": "Engineering",
      "sans": [
        "example.com",
        "www.example.com"
      ],
      "state": "California"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000,
    "total_pages": 100
  }
}
```